diff -u bzip2-1.0.5/debian/rules bzip2-1.0.5/debian/rules
--- bzip2-1.0.5/debian/rules
+++ bzip2-1.0.5/debian/rules
@@ -31,6 +31,8 @@
 DEBSTRIP:=:
 endif
 
+gen_md5sums = cd debian/tmp-$(1)/ && find -type f \! -regex '.*/DEBIAN/.*' -printf '%P\0' | xargs -r0 md5sum >DEBIAN/md5sums
+
 DEBVERSION:=$(shell head -n 1 debian/changelog \
 		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
 UPVERSION:=$(shell echo $(DEBVERSION) | sed -e 's/-[0-9.]*$$//')
@@ -134,12 +136,7 @@
 	done
 
 	# Add md5sums
-	for i in doc; do \
-	  cd debian/tmp-$$i/; \
-	  md5sum `find * -type f ! -regex "DEBIAN/.*"` >DEBIAN/md5sums </dev/null; \
-          chmod 644 debian/tmp-$$i/DEBIAN/md5sums; \
-	  cd ../..; \
-	done
+	$(call gen_md5sums,doc)
 
 	# Fix perms
 	chown -R root.root debian/tmp-doc
@@ -254,12 +251,9 @@
 	chmod +x debian/tmp-run/DEBIAN/preinst debian/tmp-lib/DEBIAN/postrm
 
 	# Add md5sums
-	for i in run dev lib; do \
-	  cd debian/tmp-$$i/; \
-	  md5sum `find * -type f ! -regex "DEBIAN/.*"` >DEBIAN/md5sums </dev/null; \
-          chmod 644 debian/tmp-$$i/DEBIAN/md5sums; \
-	  cd ../..; \
-	done
+	$(call gen_md5sums,run)
+	$(call gen_md5sums,lib)
+	$(call gen_md5sums,dev)
 
 	# Fix perms
 	chown -R root.root debian/tmp*
@@ -335,6 +329,9 @@
 	  chmod +x debian/tmp-$${i}64/DEBIAN/prerm; \
 	done
 
+	$(call gen_md5sums,lib64)
+	$(call gen_md5sums,dev64)
+
 	chown -R root.root debian/tmp*64
 	chmod -R a+rX-wts,u+w debian/tmp*64
 
@@ -395,6 +392,9 @@
 	  chmod +x debian/tmp-$${i}32/DEBIAN/prerm; \
 	done
 
+	$(call gen_md5sums,lib32)
+	$(call gen_md5sums,dev32)
+
 	chown -R root.root debian/tmp*32
 	chmod -R a+rX-wts,u+w debian/tmp*32
 
diff -u bzip2-1.0.5/debian/changelog bzip2-1.0.5/debian/changelog
--- bzip2-1.0.5/debian/changelog
+++ bzip2-1.0.5/debian/changelog
@@ -1,3 +1,11 @@
+bzip2 (1.0.5-3ubuntu1) lucid; urgency=low
+
+  * Move DEBIAN/md5sums to a macro and rewrite to be more robust using find |
+    xargs and to drop the broken chmod calls.
+  * Add md5sums for lib64, dev64, lib32, and dev32 packages; Debian #484342.
+
+ -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 15 Jan 2010 13:03:38 +0100
+
 bzip2 (1.0.5-3) unstable; urgency=low
 
   [ Santiago Ruano Rincón ]
